#include "processing.h"

#include "runtime/aio.h"
#include "runtime/buffer_manager.h"

#include <stdlib.h>

extern vy_result vyProcessPipelineFile(vy_file_id file,
                                       void *buffer,
                                       size_t size,
                                       vy_processor_output *output);

extern vy_result vyProcessShaderFile(vy_file_id file,
                                     void *buffer,
                                     size_t size,
                                     vy_processor_output *output);

int main(int argc, char **argv) {
    /* Setup */
    if (vyInitFileTab(4096) != VY_SUCCESS) {
        return 1;
    }
    if (vyInitAIO(256) != VY_SUCCESS) {
        return 1;
    }
    if (vyInitBufferManager() != VY_SUCCESS) {
        return 1;
    }

    vyInitUIDMap();

    if (vyAddAssetProcessor(".pipeline", vyProcessPipelineFile) != VY_SUCCESS)
        return 1;
    if (vyAddAssetProcessor(".shader", vyProcessShaderFile) != VY_SUCCESS)
        return 1;

    if (vyStartProcessing() != VY_SUCCESS) {
        return 1;
    }

    vyAddFileToProcessingQueue(vyAddFile("shader\\cell.pipeline"));
    while (1)
        _sleep(10);

    vyStopProcessing();
    vyShutdownFileTab();

    return 0;
}